﻿using System.Threading.Tasks;
using System.Reflection;
using UnityEngine;
using HarmonyLib;

namespace Bidon_Carry_All {
    /// <summary>
    /// Encapsulates the bidon carry all functionality to be loaded by the launcher.
    /// </summary>
    public class Bidon_Carry_All : Mod {
        /// <summary>
        /// The harmony mod reference.
        /// </summary>
        Harmony instance;

        /// <summary>
        /// Method called when the mod is first loaded by the mod manager.
        /// </summary>
        public async void Start() {
            Debug.Log("Mod Bidon_Carry_All has been loaded!");

            while (InventoryBackpack.Get() == null) {
                await Task.Delay(1000);
            }

            instance = new Harmony("Bidon_AlA_Carry_All.Nikon");
            instance.PatchAll(Assembly.GetExecutingAssembly());
        }

        /// <summary>
        /// Method called when the mod is unloaded in the mod manager.
        /// </summary>
        public void OnModUnload() {
            instance.UnpatchAll("Bidon_AlA_Carry_All.Nikon");

            Debug.Log("Mod Bidon_Carry_All has been unloaded!");
        }


    }

}
 